import java.awt.event.*;
import javax.swing.JMenuItem;
import java.awt.*;
import java.awt.Component;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JPanel;
import java.awt.Color;

public class ElementMenuListener implements ActionListener {
   private MyWorld  world;
   public ElementMenuListener (MyWorld  w){
      world = w;
   }
   @Override
   public void actionPerformed(ActionEvent e) {
            
      float adjH = -.569f;
      float adjV = -.2f;
      float railH = 2f;
      float railV = 3f;
      float cueX;
      float cueY;
      Vector2D cueVel;
      
      JMenuItem menuItem = (JMenuItem)(e.getSource());
      String text = menuItem.getText();      
      
      if (text.equals("Ball")) 
         new GBall(1f, 0.2f, new Vector2D(2f,1f),new Vector2D(2*Math.random(),2*Math.random()), world);
      if (text.equals("Wall Sideways")) 
         new GWall(new Vector2D(2f,3f), Wall.SIDEWAYS, 4f, world);
      if (text.equals("Wall Straight")) 
         new GWall(new Vector2D(2f,3f), Wall.STRAIGHT, 4f, world);
      if (text.equals("Scenario")){
          
          /*
          new GWall(new Vector2D(0f,0f), Wall.SIDEWAYS, 4f, world);
          new GWall(new Vector2D(0f,4f), Wall.SIDEWAYS, 4f, world);
          new GWall(new Vector2D(0f,0f), Wall.STRAIGHT, 4f, world);
          new GWall(new Vector2D(4f,0f), Wall.STRAIGHT, 4f, world);
    	  for (int i=0; i<20; i++)
  	         new GBall(1f, 0.2f, new Vector2D(0.5+3*Math.random(),0.5+3*Math.random()),new Vector2D(2*Math.random(),2*Math.random()), world);
          */
         
          /*********************************************************************/
          // Nueva version de 'Scenario'
          // Se emula una mesa de pool y el lanzamiento inicial con bola en mano dentro de un area de un cuarto de la mesa.
          // En el otro lado de la mesa se ubican 6 bolas en triángulo
          // La posición inicial de la bola blanca es aleatoria dentro de dicho rango.
          // El módulo de la velocidad inicial de la bola, es aleatorio, pero dicho vector siempre apunta
          // a la 'zona visible' de la primera bola del grupo triangular.
          /*********************************************************************/
          
          //Barandas y buchacas de la mesa
          new GWall(new Vector2D(adjH+.5,adjV+.5*2+railV), Wall.SIDEWAYS, railH, world);    
          new GWall(new Vector2D(adjH+.5,adjV), Wall.SIDEWAYS, railH, world);
          new GWall(new Vector2D(adjH,adjV+.5), Wall.STRAIGHT, railV, world);
          new GWall(new Vector2D(adjH+.5+railH+.7,adjV+.5*2+railV), Wall.SIDEWAYS, railH, world);
          new GWall(new Vector2D(adjH+.5+railH+.7,adjV), Wall.SIDEWAYS, railH, world);
          new GWall(new Vector2D(adjH+2*.5+2*railH+.7,adjV+.5), Wall.STRAIGHT, railV, world);
          
          // Se define un valor de viscosidad para emular el roce del paño y del aire
          world.setViscosity(.05f);
          
          // Posición de la bola blanca
          cueX = (float)(adjH+.15f+(.5+railH/2-.15f)*Math.random());
          cueY = (float)(adjV+.15f+(.5*2+railV-.15f)*Math.random());
          
          // Velocidad de la bola blanca
          cueVel = new Vector2D((adjH+.5+3*railH/2+.7+2*.15f*Math.random()-.15f)-cueX,(adjV+.5+railV/2+2*.15f*Math.random())-cueY);
          cueVel = cueVel.times(Math.random()+.5f);
          
          // Bola Blanca
          new GBall(Color.WHITE, 1f, .15f, new Vector2D(cueX,cueY),cueVel, world);
          
          // Grupo triangular de bolas
          new GBall(1f, .15f, new Vector2D(adjH+.5+3*railH/2+.7,adjV+.5+railV/2), new Vector2D(0f,0f), world);       // Primera bola (objetivo)
          new GBall(1f, .15f, new Vector2D(adjH+.5+3*railH/2+.7+2*.15f,adjV+.5+railV/2-.15f), new Vector2D(0f,0f), world);
          new GBall(1f, .15f, new Vector2D(adjH+.5+3*railH/2+.7+2*.15f,adjV+.5+railV/2+.15f), new Vector2D(0f,0f), world);
          new GBall(1f, .15f, new Vector2D(adjH+.5+3*railH/2+.7+4*.15f,adjV+.5+railV/2+2*.15f), new Vector2D(0f,0f), world);
          new GBall(1f, .15f, new Vector2D(adjH+.5+3*railH/2+.7+4*.15f,adjV+.5+railV/2), new Vector2D(0f,0f), world);
          new GBall(1f, .15f, new Vector2D(adjH+.5+3*railH/2+.7+4*.15f,adjV+.5+railV/2-2*.15f), new Vector2D(0f,0f), world);
          
      }
   }
}