import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.ImageIcon;

import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import java.net.URL;

import java.io.InputStream;
import java.io.OutputStream;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ToolBar extends JPanel implements ActionListener {
    //protected JTextArea textArea;
    protected String newline = "\n";
    static final private String LED = "led";
    static final private String SD_WALL = "sd_wall";
    static final private String ST_WALL = "st_wall";
	static final private String SLIDER = "slider";
	private MyWorld world;
	private SerialTest serial;
	//private JFrame frame =  new JFrame();
	

    public ToolBar(MyWorld w, SerialTest st, JFrame f) {
        //super(new BorderLayout());
        //Create the toolbar.
        JToolBar toolBar = new JToolBar("Componentes", JToolBar.VERTICAL);
        addButtons(toolBar);
		world = w;
		serial = st;
		//frame = f;
        //Create the text area used for output.  Request
        //enough space for 5 rows and 30 columns.
        //textArea = new JTextArea(5, 30);
        //textArea.setEditable(false);
        //JScrollPane scrollPane = new JScrollPane();

        //Lay out the main panel.
        //setPreferredSize(new Dimension(450, 100));
        //add(toolBar, BorderLayout.PAGE_START);
        //add(scrollPane, BorderLayout.CENTER);
		add(toolBar);
		
		//add(scrollPane);
    }

    protected void addButtons(JToolBar toolBar) {
        JButton button = null;

        //first button
        button = makeNavigationButton("led", LED,
                                      "Agrega un LED",
                                      "Previous");
        toolBar.add(button);

        //second button
        button = makeNavigationButton("sd_wall", SD_WALL,
                                      "Muro Horizontal",
                                      "Up");
        toolBar.add(button);

        //third button
        button = makeNavigationButton("st_wall", ST_WALL,
                                      "Muro Vertical",
                                      "Next");
        toolBar.add(button);
		
		//fourth button
        button = makeNavigationButton("slider", SLIDER,
                                      "Slider",
                                      "Slide");
        toolBar.add(button);
    }

    protected JButton makeNavigationButton(String imageName,
                                           String actionCommand,
                                           String toolTipText,
                                           String altText) {
        //Look for the image.
        String imgLocation = "images/"
                             + imageName
                             + ".gif";
        URL imageURL = ToolBar.class.getResource(imgLocation);
       
        //Create and initialize the button.
        JButton button = new JButton();
        button.setActionCommand(actionCommand);
        button.setToolTipText(toolTipText);
        button.addActionListener(this);

        if (imageURL != null) {                      //image found
            button.setIcon(new ImageIcon(imageURL, altText));
        } else {                                     //no image found
            button.setText(altText);
            System.err.println("Resource not found: "
                               + imgLocation);
        }

        return button;
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        String description = null;

        // Handle each button.
        if (LED.equals(cmd)) { //first button clicked
            //description = "taken you to the previous <something>.";
			new GBall(1f, 0.2f, new Vector2D(2f,1f),new Vector2D(2*Math.random(),2*Math.random()), world);
        } else if (SD_WALL.equals(cmd)) { // second button clicked
            new GWall(new Vector2D(2f,3f), Wall.SIDEWAYS, 4f, world);
			//new GButton(0, 0.2f, new Vector2D(2f,1f), world);
        } else if (ST_WALL.equals(cmd)) { // third button clicked
            new GWall(new Vector2D(2f,3f), Wall.STRAIGHT, 4f, world);
		} else if (SLIDER.equals(cmd)) { // fourth button clicked
            //new CreateSlider(serial);
			//frame.add(new EnergyPlotPanel(world, serial));
			JFrame frame = new JFrame();
			
			frame.setVisible(true);
			frame.pack();
			
        }
		

       /* displayResult("If this were a real app, it would have "
                        + description);*/
    }
    
	/*protected void displayResult(String actionDescription) {
        textArea.append(actionDescription + newline);
        textArea.setCaretPosition(textArea.getDocument().getLength());
		
    }*/

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event dispatch thread.
     */
	 /*
    private static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("ToolBar");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Add content to the window.
        frame.add(new ToolBar());

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }*/
	 /*
    public static void main(String[] args) {
        //Schedule a job for the event dispatch thread:
        //creating and showing this application's GUI.
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                //Turn off metal's use of bold fonts
	        UIManager.put("swing.boldMetal", Boolean.FALSE);
	        createAndShowGUI();
            }
        });
    }
*/
}